﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Data;

namespace HeuristicLab.Encodings.ConditionActionEncoding {
  public interface IXCSEvaluator : IClassifierFitnessEvaluator {
    IValueLookupParameter<DoubleValue> PredictionParameter { get; }
    IValueLookupParameter<DoubleValue> ErrorParameter { get; }
    IValueLookupParameter<IntValue> ExperienceParameter { get; }
    IValueLookupParameter<IntValue> TimestampParameter { get; }
    IValueLookupParameter<DoubleValue> AverageActionSetSizeParameter { get; }
    ILookupParameter<DoubleValue> AccuracyParameter { get; }
    ILookupParameter<DoubleValue> AccuracySumParameter { get; }
    //used for macroclassifiers
    IValueLookupParameter<IntValue> NumerosityParameter { get; }

    //inital parameters
    ILookupParameter<DoubleValue> InitialPredictionParameter { get; }
    ILookupParameter<DoubleValue> InitialErrorParameter { get; }
    ILookupParameter<DoubleValue> InitialFitnessParameter { get; }

    ILookupParameter<PercentValue> AlphaParameter { get; }
    ILookupParameter<PercentValue> BetaParameter { get; }
    ILookupParameter<DoubleValue> PowerParameter { get; }
    ILookupParameter<DoubleValue> ErrorZeroParameter { get; }
    ILookupParameter<IntValue> ActualTimeParameter { get; }
    ILookupParameter<IntValue> CurrentActionSetSizeParameter { get; }
  }
}
